/////////////////////////////////////////////////////////////////////////////
// CClientDlg.h : Declaration of the CClientDlg
//
// Simple ActiveX Control Container
//
// All rights reserved.
//
// Written by Naveen Kohli (naveen@a3ds.com)
// Version 1.0
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. to
//    naveen@a3ds.com
/////////////////////////////////////////////////////////////////////////////

#ifndef __CLIENTDLG_H_
#define __CLIENTDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#import "ActiveXCtl.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids  

/////////////////////////////////////////////////////////////////////////////
// CClientDlg
class CClientDlg : 
	public CAxDialogImpl<CClientDlg>,
	public IDispEventImpl<IDC_SHAPECTL, CClientDlg>
{
public:
	CClientDlg();

	~CClientDlg()
	{
	}

	enum { IDD = IDD_CLIENTDLG };

BEGIN_MSG_MAP(CClientDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	VOID __stdcall OnClickInShapectl(LONG x, LONG y);
public :

BEGIN_SINK_MAP(CClientDlg)
	//Make sure the Event Handlers have __stdcall calling convention
	SINK_ENTRY(IDC_SHAPECTL, 0x1, OnClickInShapectl)
	SINK_ENTRY(IDC_SHAPECTL, 0x2, OnClickOutShapectl)
	SINK_ENTRY(IDC_SHAPECTL, 0x3, OnDblClickInShapectl)
	SINK_ENTRY(IDC_SHAPECTL, 0x4, OnDblClickOutShapectl)
END_SINK_MAP()

	VOID __stdcall OnClickOutShapectl(LONG x, LONG y);
	VOID __stdcall OnDblClickInShapectl(LONG x, LONG y);
	VOID __stdcall OnDblClickOutShapectl(LONG x, LONG y);

protected:
	HWND m_ShapeCtlWnd;
	CComPtr<IShapeCtl> m_pShapeCtl;
};

#endif //__CLIENTDLG_H_
